Scriptname _mz_HT_MCMScript extends SKI_ConfigBase  
;Version 3.0

;Properties
;--------------------------------------------------
Spell property _mz_HT_CloakSpell auto
Spell property _mz_HT_ActorSpell auto
Actor property PlayerRef auto
Faction property PlayerFollowerFaction auto
;--------------------------------------------------

;MCM Actor List
;--------------------------------------------------
_mz_HT_ActorScript[] property ActorList auto hidden
;--------------------------------------------------

;MCM Options
;--------------------------------------------------
int HotkeyRemapOID_K
int RefreshDelay_S
int SearchForFollowersOID_T
;--------------------------------------------------

int ToggleKey = 35
bool HotKeyBusy = false
float property RefreshDelay = 0.0 auto hidden
bool PlayerAllHelmetsToggle = false

Event OnGameReload()
	parent.OnGameReload()
	int i = 0
	while (i < ActorList.Length)
		if (ActorList[i] == none)
			return
		else
			ActorList[i].RefreshHelmets()
			i+= 1
		endif
	endwhile
EndEvent

Event OnKeyUp(int keyCode, float holdTime)
	if Utility.IsInMenuMode()
		return
	endif
	if (keyCode == (ToggleKey) && HotKeyBusy == false)
		HotKeyBusy = true
		if (ActorList[0].ActorRef != PlayerRef)
			debug.notification("Helmet Toggle MCM Script - Hotkey error, could not find player.")
			HotKeyBusy = false
			return
		else
			if ActorList[0].ActorRef.IsOnMount()
				debug.Notification("Cannot toggle helmet while mounted.")
				utility.wait(1.0)
				HotKeyBusy = false
				return
			endif
			ActorList[0].CompileHelmetList()
			if (PlayerAllHelmetsToggle == true)
				PlayerAllHelmetsToggle = false
				debug.Notification("Show Helmet(s)")
				debug.Trace("Helmet Toggle MCM Script - Show Helmet(s) Hotkey")
			else
				PlayerAllHelmetsToggle = true
				debug.Notification("Hide Helmet(s)")
				debug.Trace("Helmet Toggle MCM Script - Hide Helmet(s) Hotkey")
			endif
		endif
		armor[] TempHelmetList = new Armor[4]
		int i = 0
		while (i < 5)
			if (ActorList[0].HelmetList[i] != None && TempHelmetList.find(ActorList[0].HelmetList[i]) < 0)
				TempHelmetList[i] = ActorList[0].HelmetList[i]
				ActorList[0].HelmetToggleState[i] = PlayerAllHelmetsToggle
			endif
			i += 1
		endwhile
		if (ActorList[0].RefreshHelmetBusy == false)
			ActorList[0].RefreshHelmetBusy = true
			ActorList[0].RefreshHelmets()
		endif
		
		
		utility.wait(1.0)
		HotKeyBusy = false
	endif	
EndEvent

Event OnConfigInit()
	;Setup MCM Actor Script List
	UnregisterForAllKeys()
	RegisterForKey(ToggleKey)
	ActorList = new _mz_HT_ActorScript[128]	
	PlayerRef.AddSpell(_mz_HT_ActorSpell)
endEvent

Event OnOptionKeyMapChange(int a_option, int a_keyCode, string a_conflictControl, string a_conflictName)
	if (a_option == HotkeyRemapOID_K)
		SetKeyMapOptionValue(a_option, a_keyCode)
		ToggleKey = a_keyCode
	endIf
	UnregisterForAllKeys()
	RegisterForKey(ToggleKey)
EndEvent

Event OnPageReset(string page)
	debug.Trace("Helmet Toggle MCM - Page Reset")
	
	;Remove Actors from list that are no longer a follower.
	int ActorIndex = 0
	while (ActorIndex < ActorList.length)
		if (ActorList[ActorIndex] == None)
			ActorIndex = ActorList.length
		elseif ( ActorList[ActorIndex].ActorRef != PlayerRef && ActorList[ActorIndex].ActorRef.GetFactionRank(PlayerFollowerFaction) < 0)
			
			debug.trace(ActorList[ActorIndex].ActorRef.GetActorBase().GetName() + " Removed from list")
			ActorList[ActorIndex].ActorRef.RemoveSpell(_mz_HT_ActorSpell)
			ActorList[ActorIndex] = None
			int i = ActorIndex
			while (i < ActorList.length)
				if (i != 127 && ActorList[i] == None && ActorList[i+1] != None)
					ActorList[i] = ActorList[i+1]
					ActorList[i+1] = None
				endif
				i += 1
			endwhile
		endif
		ActorIndex += 1
	endwhile
	
	SetCursorFillMode(TOP_TO_BOTTOM)
	HotkeyRemapOID_K = AddKeyMapOption("Toggle Player Helmet HotKey", ToggleKey)
	RefreshDelay_S = AddSliderOption("Helmet Refresh Delay", RefreshDelay, "{1} second(s)")
	SearchForFollowersOID_T = AddTextOption("Refresh Follower List", "")
	ActorIndex = 0
	while (ActorIndex < ActorList.length)
		if ActorList[ActorIndex] == None
			return
		else
			ActorList[ActorIndex].CompileHelmetList()
			Actor ActorRef = ActorList[ActorIndex].ActorRef
			Armor[] HelmetList = ActorList[ActorIndex].HelmetList
			Armor[] TempHelmetList = new Armor[5]
			ActorList[ActorIndex].HelmetMCMOption = new Int[5]
			Bool[] HelmetToggleState = ActorList[ActorIndex].HelmetToggleState

			AddHeaderOption(ActorRef.GetActorBase().GetName())
			int HelmetIndex = 0
			while (HelmetIndex < 5)
				if (HelmetList[HelmetIndex] != None && TempHelmetList.find(HelmetList[HelmetIndex]) < 0 )
					
					String HelmetName = HelmetList[HelmetIndex].GetName()
					String ToggleState = ToggleStateToString(HelmetToggleState[HelmetIndex])
					TempHelmetList[HelmetIndex] = HelmetList[HelmetIndex]
					ActorList[ActorIndex].HelmetMCMOption[HelmetIndex] = AddTextOption(HelmetName, ToggleState)
				else 
					ActorList[ActorIndex].HelmetMCMOption[HelmetIndex] = -1
				endif
				HelmetIndex += 1
			endWhile
		endif
		ActorIndex += 1
	endwhile
endEvent


Event OnOptionSliderOpen(int option)
	if (option == RefreshDelay_S)
		SetSliderDialogStartValue(RefreshDelay)
        SetSliderDialogDefaultValue(0.0)
        SetSliderDialogRange(0.0, 5.0)
        SetSliderDialogInterval(0.1)
	endif
endEvent


Event OnOptionSliderAccept(int option, float value)
    if (option == RefreshDelay_S)
        RefreshDelay = value
        SetSliderOptionValue(RefreshDelay_S, RefreshDelay, "{1} second(s)")
	endif
endEvent

Event OnOptionSelect(int option)
	int ActorIndex = 0
	if (option == SearchForFollowersOID_T)

		SetTextOptionValue(SearchForFollowersOID_T, "Refreshing")
		
		PlayerRef.AddSpell(_mz_HT_CloakSpell, false)
		while (Utility.IsInMenuMode() == true)
			Utility.Wait(0.1)
		endwhile
		Utility.Wait(5.0)
		PlayerRef.RemoveSpell(_mz_HT_CloakSpell)
		return
	endif
	
	while (ActorIndex < ActorList.Length)
		_mz_HT_ActorScript ActorScript = ActorList[ActorIndex]
		if (ActorScript != None)
	
			int OptionIndex = 0
			while(OptionIndex < 5) 
				if (option == ActorScript.HelmetMCMOption[OptionIndex])
					if ActorScript.ActorRef.IsOnMount()
						while Utility.IsInMenuMode()
							Utility.wait(0.1)
						endwhile
						debug.notification("Cannot toggle helmet while character is mounted.")
						return
					else
						debug.Trace("Helmet Toggle MCM - Toggling Helmet " + ActorScript.HelmetList[OptionIndex].GetName() + " on actor " + ActorScript.ActorRef.GetActorBase().GetName())
						SetTextOptionValue(ActorScript.HelmetMCMOption[OptionIndex], "Toggling")
						if (ActorScript.HelmetToggleState[OptionIndex] == true)
							ActorScript.HelmetToggleState[OptionIndex] = false
						else
							ActorScript.HelmetToggleState[OptionIndex] = true
						endif
					endif
				endif
				
				OptionIndex += 1
			endWhile
			if (ActorScript.RefreshHelmetBusy == false)
				ActorScript.RefreshHelmetBusy = true
				ActorScript.RefreshHelmets()
			endif
		else
			ActorIndex = ActorList.Length
		endif
		ActorIndex += 1
	endwhile
endEvent

String Function ToggleStateToString(bool ToggleState)
	if (ToggleState)
		return "Show"
	else
		return "Hide"
	endif
endFunction